;> *********************************
;> * LILO MASTER BOOT RECORD (MBR) *
;> *********************************
;> M.Campinoti 07/12/99
;> DISASSEMBLATO CON NDISASM 0.97
;> 
;> FORMATO DEL Master Boot Sector STANDARD:
;> Offset	Size		Description	
;> 00h 		446 BYTEs	Master bootstrap loader code
;>1BEh 		16 BYTEs	partition record for partition 1 
;>1CEh 		16 BYTEs	partition record for partition 2
;>1DEh 		16 BYTEs	partition record for partition 3
;>1EEh 		16 BYTEs	partition record for partition 4
;>1FEh		1 WORD		signature, AA55h indicates valid boot block

00000000  FA                cli			;SPENGE GLI INTERRUPT
00000001  EB6C              jmp short 0x6f	;SALTA 0000006F

;> QUESTA SARA' L'AREA DATI DI LILO ? CI SARA'ANCHE IL SUPERBLOCK?
;> ---------------------------------------------------------------
00000003  0000              add [bx+si],al
00000005  004C49            add [si+0x49],cl	;DA 00000003 CI SONO TRE "00" E POI "LILO"
00000008  4C                dec sp		;0x4C="L" 0x49="I" 0x4C="L" 0x4F="O"
00000009  4F                dec di
0000000A  0100              add [bx+si],ax
0000000C  1400              adc al,0x0
0000000E  B500              mov ch,0x0
00000010  0000              add [bx+si],al
00000012  0000              add [bx+si],al
00000014  01CD              add bp,cx
00000016  6F                outsw
00000017  38063500          cmp [0x35],al
0000001B  0101              add [bx+di],ax
0000001D  07                pop es
0000001E  350001            xor ax,0x100
00000021  0105              add [di],ax
00000023  350001            xor ax,0x100
00000026  0101              add [bx+di],ax
00000028  8C00              mov [bx+si],es
0000002A  0935              or [di],si
0000002C  0001              add [bx+di],al
0000002E  010A              add [bp+si],cx
00000030  350001            xor ax,0x100
00000033  010A              add [bp+si],cx
00000035  350000            xor ax,0x0
00000038  010B              add [bp+di],cx
0000003A  350000            xor ax,0x0
0000003D  010C              add [si],cx
0000003F  350000            xor ax,0x0
00000042  010D              add [di],cx
00000044  350000            xor ax,0x0
00000047  010E3500          add [0x35],cx
0000004B  0001              add [bx+di],al
0000004D  0F                db 0x0F
0000004E  350000            xor ax,0x0
00000051  0110              add [bx+si],dx
00000053  350000            xor ax,0x0
00000056  0111              add [bx+di],dx
00000058  350000            xor ax,0x0
0000005B  0100              add [bx+si],ax
0000005D  0000              add [bx+si],al
0000005F  0000              add [bx+si],al
00000061  0000              add [bx+si],al
00000063  0000              add [bx+si],al
00000065  0000              add [bx+si],al
00000067  0000              add [bx+si],al
00000069  0000              add [bx+si],al
0000006B  0000              add [bx+si],al
0000006D  0000              add [bx+si],al
;> -----------------------------------------

;> ****************************************************************
;> * FINE DELL'AREA DATI, INIZIA IL CODICE DI LILO VERO E PROPRIO *  
;> ****************************************************************

0000006F  B8C007            mov ax,0x7c0		;AX=0x7C00 (IL BIOS CARICA QUI I MBR)
00000072  8ED8              mov ds,ax			;DS=0x7C00 (SEGMENTO DATI)
00000074  8C066A00          mov [0x6a],es		;ES=0x0000 (PRESO DALL'AREA DATI DI LILO)
00000078  89366800          mov [0x68],si		;SI=0x0000 (PRESO DALL'AREA DATI DI LILO) 
0000007C  891E6C00          mov [0x6c],bx		;BX=0x0000 (PRESO DALL'AREA DATI DI LILO)
00000080  88166E00          mov [0x6e],dl		:DL=0x0000 (PRESO DALL'AREA DATI DI LILO)
00000084  B8009A            mov ax,0x9a00		;AX=0x9A00
00000087  8EC0              mov es,ax			;ES=0x9A00 
00000089  B90001            mov cx,0x100		;CX=0x100 (256 IN DECIMALE)
0000008C  29F6              sub si,si			;AZZERA REGISTRO SI
0000008E  29FF              sub di,di			;AZZERA REGISTRO DI
00000090  FC                cld				;AZZERA DIRECTION FLAG (CONTATORE IN AVANTI)
00000091  F3A5              rep movsw			;COPIA 256 WORD (512 BYTE) ALL'INDIRIZZO 9A00:0000
00000093  EA9800009A        jmp 0x9a00:0x98		;SALTA DOVE HA COPIATO IL CODICE

;> QUESTO CODICE SI TROVERA' ALL'INDIRIZZO 9A00:0098 .... ED E' ADESSO ESEGUITO

00000098  FA                cli				;SPENGE GLI INTERRUPT
00000099  8ED8              mov ds,ax			;DS=0x9A00
0000009B  8EC0              mov es,ax			;ES=0x9A00
0000009D  BC00B0            mov sp,0xb000		;SP=0xB000
000000A0  B80090            mov ax,0x9000		;AX=0x9000
000000A3  8ED0              mov ss,ax			;SS=0x9000
000000A5  FB                sti				;RIACCENDE GLI INTERRUPT

000000A6  B00D              mov al,0xd			;AL=0x0D (PASSATO COME PARAMETRO)
000000A8  E85B00            call 0x106			;STAMPA IL CARATTERE 0x0D ("CR")
000000AB  B00A              mov al,0xa			;AL=0x0A (PASSATO COME PARAMETRO)
000000AD  E85600            call 0x106			;STAMPA IL CARATTERE 0x0A ("LF")
000000B0  B04C              mov al,0x4c			;AL=0x4C (PASSATO COME PARAMETRO)
000000B2  E85100            call 0x106			;STAMPA IL CARATTERE 0x4C ("L")
000000B5  BE3400            mov si,0x34			;SI=0x34
000000B8  B8000B            mov ax,0xb00		;AX=0x0B00
000000BB  8EC0              mov es,ax			;ES=0x0B00
000000BD  31DB              xor bx,bx			;AZZERA BX
000000BF  FC                cld				;AZZERA IL DIRECTION FLAG
000000C0  AD                lodsw			;CARICA IN AX LA WORD PUNTATA DA DS:SI 								;(SI=SI+1)
							;PUNTA CON OFFSET 0x34 NELLA PRECEDENTE 							;AREA DATI E CARICA IN AX LA WORD 0x0A35
000000C1  89C1              mov cx,ax			;CX=AX=0x0A35
000000C3  AD                lodsw			;CARICA LA WORD SUCCESSIVA...
000000C4  89C2              mov dx,ax			;DX=AX=0x0000
000000C6  09C8              or ax,cx			;ESEGUE L'OR ESCLUSIVO TRA AX E CX, 								;RISULTATO IN AX
000000C8  7420              jz 0xea			;SALTA SE AX=0x00 ALLA LABEL 000000EA
000000CA  46                inc si			;ALTRIMENTI INCREMENTA SI
000000CB  E84300            call 0x111			;E CHIAMA LA SUBROUTINE 000000111
000000CE  7206              jc 0xd6			;SALTA A 000000D6 SE LA SUBROUTINE 
							;000000111 RITORNA CF = 1 (ERRORE)
000000D0  81C30002          add bx,0x200		;BX=BX+0x0200
000000D4  EBEA              jmp short 0xc0		;SALTO INCONDIZIONATO A 000000C0
							;CONTINUA A CARICARE DATI DALL'AREA 								;PRECEDENTE
000000D6  50                push ax			;METTE AX SULLO STACK
000000D7  B020              mov al,0x20			;CARICA AL=0x20 (PARAMETRO DA PASSARE)
000000D9  E82A00            call 0x106			;STAMPA IL CARATTERE 0x20 ("SPAZIO")
000000DC  58                pop ax			;RIPRISTINA IL VECCHIO AX DALLO STACK
000000DD  88E0              mov al,ah			;AL=AH (PARAMETRO DA PASSARE)
000000DF  E81200            call 0xf4			;CHIAMA LA SUBROUTINE 000000F4
000000E2  31C0              xor ax,ax			;AZZERA AX (SERVIZIO 0, RIAZZERA UNITA')
000000E4  88C2              mov dl,al			;DL=AL=0x00
000000E6  CD13              int 0x13			;INT 13 (RIAZZERA UNITA' DISCHI)
000000E8  EBCB              jmp short 0xb5		;TORNA ALLA LABEL 000000B5
000000EA  B049              mov al,0x49			;CARICA AL=0x49 (PARAMETRO DA PASSARE)
000000EC  E81700            call 0x106			;STAMPA IL CARATTERE 0x49 ("I")
000000EF  EA0000000B        jmp 0xb00:0x0		;SALTA AL CODICE A 0B00:0000
							
;> **************************************************************************
;> * QUI INIZIANO LE SUBROUTINE CHIAMATE DAL CORPO PRINCIPALE DEL PROGRAMMA *
;> **************************************************************************

;> CODICE DELLA SUBROUTINE 000000F4
;> STAMPA IL CODICE DI ERRORE RELATIVO
;> ALLE PRECEDENTI ROUTINE (VEDI 000000111)
;> -----------------------------------
000000F4  50                push ax			;SALVA AX SULLO STACK
000000F5  C0E804            shr al,0x4			;SHIFTA A DESTRA AL DI 4 (MOLTIPLICAZIONE)
000000F8  E80100            call 0xfc			;CHIAMA LA SUBROUTINE 000000FC
000000FB  58                pop ax			;RIPRISTINA AX DALLO STACK	
000000FC  240F              and al,0xf			;AND AL CON 0x0F RISULTATO IN AL
000000FE  0430              add al,0x30			;SOMMA 0x30 AD AL (IL CODICE DI ERRORE
							;E' TRASFORAMTO IN CODICE NUMERICO 
							;"HUMAN READABLE")
00000100  3C3A              cmp al,0x3a			;CONFRONTA AL CON 0x3A
00000102  7202              jc 0x106			;SE CF == 1 STAMPA CARATTERE
00000104  0407              add al,0x7			;ALTRIMENTI AL=AL+0x07

;> CODICE DELLA SUBROUTINE 000000106 
;> (STAMPA UN CARATTERE A VIDEO )
;> -----------------------------------
00000106  30FF              xor bh,bh			;AZZERA BH
00000108  B40E              mov ah,0xe			;AH=0x0E (SERVIZIO 0x0E DELL'INT 0x10)	
0000010A  CD10              int 0x10			;STAMPA A VIDEO UN CARATTERE (INT DEL BIOS)
0000010C  C3                ret				;RITORNA DA SUBROUTINE
;> -----------------------------------

;> USATA DA MOLTE ROUTINE PER RITORNARE INDIETRO
;> (VEDI CASO DI ERRORE DELLA 000000111)
;> ---------------------------------------------
0000010D  5A                pop dx			;RIPRISTINA DALLO STACK DX
0000010E  59                pop cx			;RIPRISTINA DALLO STACK CX
0000010F  5B                pop bx			;RIPRISTINA DALLO STACK BX
00000110  C3                ret				;E RITORNA DALLA SUBROUTINE

;> CODICE DELLA SUBROUTINE 000000111 
;> 1.PRENDE I PARAMETRI DEL DISCO FISSO
;> 2.ESEGUE I CALCOLI PER CARICARE UNA TRACCIA (DOVE IL KERNEL RISIEDE?)
;> 3.CARICA LA TRACCIA (DEL KERNEL?)
;> 4.RITORNA GLI ERRORI DI LETTURA/LOCAZIONE
;> -----------------------------------
00000111  F6C240            test dl,0x40		;EFFETTUA IL TEST DEL 3 BIT DEL REG.DL	
							;GUARDA SE SIAMO IN BOOT DA FD OPPURE HD
00000114  7454              jz 0x16a			;SE E' ZERO SALTA A 00000016A
00000116  80E2BF            and dl,0xbf			;ALTRIMENTI ESEGUE AND CON 10111111
00000119  53                push bx			;SALVA BX SULLO STACK
0000011A  51                push cx			;SALVA CX SULLO STACK	
0000011B  52                push dx			;SALVA DX SULLO STACK
0000011C  B408              mov ah,0x8			;AH=0x08 (SERVIZIO 0x08 DELL'INT 0x13)
							;OTTIENE I PARAMETRI DI UNA UNITA'HD								;FUNZIONA SOLO CON GLI HARD DISK...
							;QUESTO SERVIZIO VUOLE COME PARAMETRI:
							;DL=NUMERO DEL DISCO FISSO AH=0x08
							;E RITORNA QUESTI DATI:
							;CH=NUMERO DI TRACCE/FACCIA
							;CL=NUMERO DI SETTORI/TRACCIA
							;DH=NUMERO DI FACCE
							;DL=NUMERO DI UNITA' DISCO COLLEGATE
0000011E  CD13              int 0x13			;CHIAMA INT 0x13
00000120  72EB              jc 0x10d			;SE IL CF==01 (ERRORE) VAI A 00000010D
							;ALTRIMENTI SI PROSEGUE CON L'ELABORAZIONE
00000122  88F0              mov al,dh			;AL=DH (NUMERO DI FACCE)
00000124  5A                pop dx			;RIPRENDE DX DALLO STACK
00000125  88167701          mov [0x177],dl		;METTE DL NELLA WORD PUNTATA DA 0x177 
							;(N DI UNITA'DISCHI CONSECUTIVE COLLEGATE)
00000129  88F2              mov dl,dh			;DL=DH (NUMERO DI FACCE)
0000012B  30F6              xor dh,dh			;AZZERA DH
0000012D  51                push cx			;SALVA CX SULLO STACK 
							;(CH=TRK/SIDE CL=SECT/TRACK)
0000012E  86CD              xchg cl,ch			;SCAMBIA TRA LORO CL E CH
00000130  D0C5              rol ch,1			;SCORRE A DESTRA CH DI 1 BYTE
00000132  D0C5              rol ch,1			;SCORRE A DESTRA CH DI 1 BYTE 
							;4*(SECT/TRACK)
00000134  80E503            and ch,0x3			;CH AND 0x03 (00000011) RISULTATO IN CH
00000137  890E7501          mov [0x175],cx		;METTE CX COSI CALCOLATO
							;NELLA WORD PUNTATA DA 0x175
0000013B  59                pop cx			;RIPRENDE CX DALLO STACK
0000013C  83E13F            and cx,byte +0x3f		;AND CX CON 00111111 RISULTATO IN CX
0000013F  F6E1              mul cl			;MOLTIPLICA CL PER SE STESSO,RISULTATO CX
							;(SECT/TRACK)*(SECT/TRACK)
00000141  01C8              add ax,cx			;AGGIUNGE IL RISULTATO A AX (AX=AX+(CL*CL))
							;NUMERO DI FACCE+(SECT/TRACK)*(SECT/TRACK)
00000143  93                xchg ax,bx			;SCAMBIA AX CON BX
00000144  58                pop ax			;RIPRENDE AX DALLO STACK
00000145  F7F3              div bx			;DIVIDE BX
00000147  92                xchg ax,dx			;SCAMBIA AX CON DX
00000148  F6F1              div cl			;DIVIDE CL
0000014A  FEC4              inc ah			;INCREMENTA AH (AH=AH+1)
0000014C  88267801          mov [0x178],ah		;METTE AH NEL BYTE PUNTATO DA 0x178
00000150  92                xchg ax,dx			;SCAMBIA AX E DX
00000151  88D6              mov dh,dl			;DH=DL
00000153  8A167701          mov dl,[0x177]		;METTE DL NEL BYTE PUNTATO DA 0x177
00000157  3B067501          cmp ax,[0x175]		;CONFRONTA AX COL BYTE PUNTATO DA 0x175
0000015B  7713              ja 0x170			;JUMP IF ABOVE A SUBROUTINE 000000170
0000015D  86C4              xchg al,ah			;SCAMBIA AL E AH
0000015F  D0C8              ror al,1			;SCORRE A DESTRA AL DI 1 BIT
00000161  D0C8              ror al,1			;SCORRE A DESTRA AL DI 1 BIT (E SIAMO DUE)
00000163  0A067801          or al,[0x178]		;OR DI AL CON IL BYTE CONTENUTO IN 0x178
00000167  89C1              mov cx,ax			;CX=AX
00000169  5B                pop bx			;RECUPERA BX DALLO STACK
0000016A  B80102            mov ax,0x201		;(SERVIZIO 02 LEGGI SETTORI DAL DISCO)
							;AH=0x02 
							;AL=NUMERO DI SETTORI DA LEGGERE (QUI 1)
							;BX=INDIRIZZO OFFSET BUFFER DATI
							;CH=TRACCIA CL=SETTORE
							;DH=FACCIA DL=NUMERO DRIVE
							;ES=INDIRIZZO SEGMENTO BUFFER DATI	
0000016D  CD13              int 0x13			;CHIAMA INT 0x13
							;IN AH C'E' IL CODICE DI RITORNO
0000016F  C3                ret				;RITORNA DALLA SUBROUTINE
;> -----------------------------------

;> CODICE DELLA SUBROUTINE 000000170
;> -----------------------------------
00000170  5B                pop bx			;RECUPERA BX DALLO STACK
00000171  31C0              xor ax,ax			;AZZERA AX
00000173  F9                stc				;CF = 1 (SETTA IL CARRY FLAG)
00000174  C3                ret				;RITORNO DA SUBROUTINE
;> -----------------------------------

;> QUESTI SONO BYTE CHE "AVANZANO" DEL MBR

00000175  0000              add [bx+si],al
00000177  0000              add [bx+si],al
........
........
000001F9  0000              add [bx+si],al
000001FB  0000              add [bx+si],al

;> CODICE 0x55AA PER DIRE AL BIOS CHE LA PARTITION TABLE E' VALIDA.

000001FD  0055AA            add [di-0x56],dl
